/*
 * SirvNET Services are copyright (c) 1998-2006 Trevor Klingbeil.
 *    http://www.sirv.net  ::  ftp.sirv.net
 * This program is copyrighted software; see the file COPYING for details.
 */

#ifndef EXTERN_H
#define EXTERN_H



#define E extern

#define get_random(min, max) ((rand() % (long)(((max)+1) - (min))) + (min))
#define fetch mysql_fetch_row

#define DEL    0
#define ADD    1


#ifdef CONVERT_29_ANOPE

/****   altdb.c  ****/


E int convert29();
E int convert17();



#endif /* CONVERT_29_ANOPE */



/****   channels.c  ****/

E unsigned int cchans, maxchans;
E CloseChans *closelist;
E ChannelNode *chanlist;
E unsigned int monitored;
E void load_chaninfo();
E void process_channel_burst();
E void m_sjoin(char *source, int ac, char **av);
E void chan_deluser(User *client, Channel *c);
E void chan_addop(const char *chan, const char *nick, int type);
E void chan_delop(const char *chan, const char *nick, int type);
E void chan_addban(const char *chan, const char *mask, int setban);
E void chan_delban(const char *chan, const char *mask);
E Channel *findchan(const char *chan);
E ChanInfo *findchaninfo(const char *chan);
E int in_chan(const char *nick, const char *chan);
E int is_chanop(const char *nick, const char *chan);
E int is_voiced(const char *nick, const char *chan);
E int is_halfop(const char *nick, const char *chan);
E void do_part(char *source, int ac, char **av);
E void delete_uchans(User *u);
E void do_kick(char *source, int ac, char **av);
E ChanInfo *add_ci_chan(const char *chan, const char *founder, long flags);
E void del_ci_chan(const char *chan);
E void do_topic(char *source, int ac, char **av);
E void expire_chans();
E int succeed_chan(const char *chan);
E int chan_closed(const char *chan);
E ChanInfo *official_list(ChanInfo *ci, int opt);


/****   chanserv.c  ****/

E void chanserv(const char *source, char *buf);
E int check_cs_command(const char *cmd);
E inline void update_cs_table(int cmd, int newlevel);
E int get_access(User *u, const char *chan, char **ntrace, int caccess);
E void check_welcome(const char *source, const char *chan);
E int check_should_op(User *u, const char *chan);
E int check_valid_op(User *u, const char *chan);
E int check_op_protect(User *u, const char *chan);
E int check_topiclock(ChanInfo *ci, const char *source);
E int check_should_kick(User *u, const char *chan);
E void expire_chanlists(const char *nick);
#ifdef UNREAL
E void check_special_op(User *u, const char *chan);
#endif



/****   clones.c  ****/

E void load_triggers();
E void do_trigger(const char *source, const char *service);
E void do_clones(const char *source, const char *service);
E void check_clones(User *user);
E void userhost_list(User *user, int add, int *hosts, int *names);

/****   conf.c  ****/

E int READ_ONLY;

E char *log_name;
E char *conf_name;
E char *local_ip;

E char *allow_ips[24];
E Masters *masterlist;
E BadEmails *bademails;

E short ALLOW_EMAIL;
E short AUTH_EMAIL;
E short NSECURE;
E short LOGON_NEWS;
E short GENERIC_NOTICE;
E short ORGANIZE;
E char *SENDMAIL_PATH;
E char *RETURN_EMAIL;
E short BAD_PW_LIMIT;
E short BAD_PW_TIMEOUT;
E short ENABLE_R_MODES;
E short FLOOD_PROT;
E short F_TLEV;
E short F_RESET;
E short ACCESS_MAX;
E short DISABLE_PRIVMSG;
E short ENABLE_GETPASS;
E int BLOCK_EMAIL_TIME;
E char *HELPSERV_DIR;
E short HIGH_NICK_SECURITY;
E int XAUTH_TIME;
E int NICK_EXPIRE;
E unsigned long UPDATE_TIMEOUT;
E short DISPLAY_UPDATES;
E short ALLOW_LIST;
E int LIST_MAX;
E int MAX_EMAILS;
E short FORBID_OPERS;
E short SNOOP;
E char *SNOOPCHAN;
E short MOTD_UPTIME;
E float AKILL_PERCENT;
E short DETECT_CLONES;
E short CLONE_MIN_USERS;
E short CLONE_WARNING_DELAY;
E short LOG_IDENTIFIES;
E int NS_REG_DELAY;
E short sdebug;
E short SEND_LOGS;
E short AKILL_CLONES;
E char *CKILL_TIME;
E char *CKILL_WHO;
E short CKILL_COUNT;
E char *DEF_MLOCKS;
E int CHAN_EXPIRE;
E short CHAN_ACC_MAX;
E short CHAN_LIST_MAX;
E short CHAN_REMOVE;
E short CHAN_INHABIT;
E short REMINDER_DAYS;
E int MAX_MEMO_LENGTH;
E short MAX_MEMOS;
E short MEMO_WAIT;
E int MEMO_EXPIRE;
E int RELEASE_TIMEOUT;
E short MAX_NICKS;
E short MAX_CHANS;
E short AKILL_REASONS;
E char *SMTP_SERVER;
E char *SMTP_LOGIN;
E char *SMTP_PASS;
E short ALLOW_LITERAL;
E int TRIMBANS;
E int TRIMBANS_REMOVE;
E short DEF_NS_ENFORCE;
E short DEF_NS_SECURE;
E short DEF_NS_HIDE;
E short DEF_CS_KEEPTOPIC;
E short DEF_CS_IDENT;
E int FORCE_MEMO_LEVEL;
E short MASK_HOSTNAME;
E short BACKUP_DB;
E unsigned long BACKUP_UPDATE;
E short WEB_UPDATE;
E short WEB_UPDATE_HOURS;
E short DISPLAY_VERSION;
E int SMTP_RESEND_TIME;
E int SMTP_RETRIES;


E int init_conf();
E void rehash_conf();


E char *remote_servername;
E char *remote_server;
E unsigned long services_port;
E char *services_pass;
E char *servername;
E char *services_desc;
E char *services_user;
E char *services_host;
E char *NETWORK_NAME;
E char *services_master;
E char *statsname;

E char *s_NickServ;
E char *s_ChanServ;
E char *s_MemoServ;
E char *s_HelpServ;
E char *s_OperServ;
E char *s_RootServ;
E char *s_Global;
E char *s_StatServ;

E char *SQL_HOST;
E char *SQL_USER;
E char *SQL_PASS;
E char *SQL_DB;
E int SQL_PORT;


E int TIMEOUT_CHECK;
E int SQL_CHECK;
E int CONNECT;
E int SERV_LISTEN_PORT;
E int RECONNECT;
E int RECON_FREQ;

/****   email.c   ****/

E inline void e_mail(const char *info, const char *subject, const char *email, int append);
E void add_email(const char *info, int type);
E int check_email(const char *info, int type, int incr);
E int check_valid_email(const char *email);
E int check_bad_email(const char *email);
E void kill_emails();
E void select_smtp();



/****   extern.h   ****/

E int encryptm(const char *src, int len, char *dest, int size, int usext);
E int check_password(const char *plaintext, const char *password);


/****   hash.c  ****/

E void nick_hash(char *nick, unsigned long *ret);



/****   help.c  ****/

E void do_help(const char *service, const char *source, char *buf, int level);


/****   init.c  ****/

E int init();





/****  log.c  ****/

E FILE *logfile;

E void check_logs(void);
E int open_logs();
E void close_logs();
E void slog(int type, const char *fmt, va_list args);
E void blog(const char *service, const char *fmt,...);


/****   main.c  ****/


E char inbuf[512];
E int nofork;
E int debug, debug_traffic;
E int sshutdown;
E time_t start_time;

E fd_set master, read_fds, smtp_fdlist, smtp_read_fds;
E int fdmax, smtp_fdmax;

E int sql_alive;
E int use_services;
E int use_stats;
E int use_sql;
E int uburst;
E int cburst;
E int skeleton_mode;

E void fatal_error(const char *fmt,...);


/***   memory.c   ***/

E nfreezes *freezelist;
E char *sstrdup(const char *s);
E void *smalloc(size_t msize);
E void *srealloc(void *ptr, size_t newsize);
E void *scalloc(long elsize, long els);
E void freeze(const char *f, int freeze);
E void load_closures();
E void load_freezes();
E void load_akills();
E void load_ignores();


/****   memoserv.c   ****/

E void memoserv(const char *source, char *buf);
E inline void update_ms_table(int cmd, int newlevel);
E void expire_memos();
E void email_memo(NickInfo *ni, const char *memo, const char *sender);
E int check_ms_command(const char *cmd);
E void check_memos(User *user, int id);


/****   messages.c  ****/

E unsigned long scommands;
E unsigned long ucommands;
E void send_logonnews(User *u);
E int pingburst;

/****   misc.c  ****/

E char *calcltime(time_t t);
E char *timebuf(time_t tnum);
E char *merge_args(int argc, char **argv);
E void load_pseudo_clients(const char *user);
E void cripple_pseudo();
E void globops(const char *source, const char *fmt,...);
E void notice(const char *source, const char *dest, const char *fmt,...);
E int match_wild(const char *pattern, const char *str);
E int match_wild_nocase(const char *pattern, const char *str);
E int check_servii_kill(const char *source, int ac, char **av);
E char *strupper(char *s);
E char *strlower(char *s);
E inline long getrandom(int min, int max);
E char *opertrace(User *u, int db);
E void kill_user(const char *source, const char *target, const char *reason);
E int is_on_master_list(const char *nick);
E int is_on_root_list(const char *nick);
E void check_jupe(const char *server);
E char *create_ticket();
E int check_valid_url(const char *source, const char *url);
E int check_valid_mask(const char *mask);
E int check_valid_host(const char *host);
E int check_valid_ip(const char *ip);
E void expire_akills();
E void send_akills();
E void send_sqlines();
E void send_sglines();
E void update_akills();
E int akill_key(const char *mask);
#ifdef BAHAMUT
E void ircd_akill(const char *source, const char *mask, const char *reason, char *code, int timed);
#endif
E inline int is_frozen(const char *nick);
E char *gettok(char *buf, const char *delim, int LENMAX);
E int check_escape_codes(const char *s);
E long generate_primary_id(const char *table);
E char *mask_host(const char *usermask);
E void bad_password(User *u, const char *target);
E int check_ignore(const char *username, const char *host);
E int check_akill(const char *nick, const char *username, const char *host);
E void expire_ignores();
E void expire_closures();
E void mass_check_akill();



/****   modes.c  ****/

E void u_mode(const char *source, int ac, char **av);
E void c_mode(const char *source, int ac, char **av);
E void check_modes(Channel *c, ChanInfo *ci);
E long def_mlocks(int setting);
E char *get_cmodes(ChanInfo *ci);


/****   nickserv.c   ****/

E void load_nickinfo();
E NickInfo *findnick(const char *nick);
E inline long nick_flags(const char *nick);
E void nickserv(const char *source, char *buf);
E void add_idnick(User *u, const char *nick);
E void validate_user(User *u, int newuser);
E void cancel_user(User *u);
E int expire_pends();
E void expire_nicks(int xauth);
E int check_ns_command(const char *cmd);
E inline void update_ns_table(int cmd, int newlevel);
E char *show_options(char *buf, long flags);
E long generateid(User *u, const char *target, unsigned long id);
E void update_nick_flags(const char *nick, long flags);
E inline int nick_registered(const char *nick);
E int is_recognized(const char *user, const char *nick);
E int is_identified(const char *user, const char *nick);
E int is_authed(const char *nick);


/****   oper.c   ****/

E AKill *akill_list;
E Ignore *ignore_list;
E void rootserv(const char *source, char *buf);
E void operserv(const char *source, char *buf);
E void akills(const char *mask, int add, int id);
E void update_oper_table(int cmd, int newlevel);
E int check_oper_command(const char *cmd);
E void ignores(const char *mask, int add);

/****   permissions.c    ****/

E void init_operconf();
E int has_access(const char *source, int level);


/****   servers.c   ****/

E ServerList *myhub;
E void add_server(const char *hub, const char *leaf);
E void squit_server(const char *server);
#ifdef SKELETON
E void split_main();
E void join_main();
E void check_main();
#endif
E void user_add_server(User *u);
E void user_del_server(User *u);


/****   servutil.c   ****/

E int serv_start();
E void serv_lost();
E void accept_serv();


/****   process.c   ****/

E void process(int target);


/****   news.c   ****/

E unsigned int last_news_id;
E void load_news();
E void do_news(const char *source);



/****   socket.c   ****/

E int servfd, servlfd, updatefd;

E int init_updatesock();
E int init_servsock(const char *rserv, int rport);
E int serv_connect();
E void send_cmd(const char *source, const char *fmt,...);
E char *newmsg(int sock, char *buf, unsigned int size);
E inline void send_svinfo();
E int update_connect();
E void web_update_check();
E void end_web_check();
E int serv_listen();



/****   statserv.c   ****/

E void statserv(const char *source, char *buf);


/****   sql.c   ****/

E MYSQL mysql;
E MYSQL_RES *res, *res2, *res3;
E MYSQL_ROW row, row2, row3;
E MYSQL_FIELD *field;

E int connect_sql();
E int sql_select(const char *fmt,...);
E inline void free_sql();
E char *retrieve_day();
E int send_sql(const char *fmt,...);
E int sql_connect();
E int ping_sql();
E void sql_quit();
E void check_mlines();
E void backup_routine();


/****   users.c   ****/

E User *userlist[256];
E User *finduser(const char *nick);
E char *create_mask(User *u);
E int match_usermask(const char *mask, User *user);
E int check_r_mode(User *user);
E void do_nick(char *source, int ac, char **av);
E int is_oper(const char *nick);
E unsigned int usercnt, maxusercnt, opcnt;
E void do_kill(char *source, int ac, char **av);
E void do_quit(char *source, int ac, char **av);
E int do_update_flood(User *u, unsigned short idflood);
E void newuser_routines(User *u);
E void delete_user(User *user);



#endif  /* EXTERN_H */

