/* Time-delay routine include stuff.
 *
 * SirvNET Services is copyright (c) 1998-2006 Trevor Klingbeil.
 *     E-mail: <talinon@sirv.net>
 * This program is copyrighted software; see the file COPYING for details.
 * Originally based on EsperNet Services(c) by Andy Church.
 */

#ifndef TIMEOUT_H
#define TIMEOUT_H

#include <time.h>

/* Definitions for timeouts: */
typedef struct timeout_ Timeout;
struct timeout_ {
    Timeout *next, *prev;
    time_t settime, timeout;
    int repeat;			/* Does this timeout repeat indefinitely? */
    void (*code)(Timeout *);	/* This structure is passed to the code */
    void *data;			/* Can be anything */
    int flagged;               /* do not delete timeout no matter what - SVSNICK fix */
};


E void check_nick(char *nick, const char *newnick);

/* Check the timeout list for any pending actions. */
E void check_timeouts(void);

/* Add a timeout to the list to be triggered in `delay' seconds.  Any
 * timeout added from within a timeout routine will not be checked during
 * that run through the timeout list.
 */

E Timeout *add_timeout(int delay, void (*code)(Timeout *), int repeat);

E int check_release(const char *nick);

/* Remove a timeout from the list (if it's there). */
E void del_ntimeout(const char *nick, int remove_t);
E void del_timeout(Timeout *t);



#endif	/* TIMEOUT_H */
