/*
 * SirvNET Services are copyright (c) 1998-2006 Trevor Klingbeil.
 *    http://www.sirv.net  ::  ftp.sirv.net
 * This program is copyrighted software; see the file COPYING for details.
 */

#include "services.h"

/*********************************************************************************************/
/*********************************************************************************************/


FILE *logfile;


/*********************************************************************************************/

static void create_dummy_logs(void)
{
	FILE *templog;

	templog = fopen("./logs/temp.log", "a");
	fclose(templog);
	templog = fopen("./logs/ns_reg.log", "a");
	fclose(templog);
	templog = fopen("./logs/ns_id.log", "a");
	fclose(templog);
	templog = fopen("./logs/ns_own.log", "a");
	fclose(templog);
	templog = fopen("./logs/ns_gpd.log", "a");
	fclose(templog);
	templog = fopen("./logs/ns_flags.log", "a");
	fclose(templog);
	templog = fopen("./logs/ns_misc.log", "a");
	fclose(templog);
	templog = fopen("./logs/ns_exp.log", "a");
	fclose(templog);
	templog = fopen("./logs/rs.log", "a");
	fclose(templog);
	templog = fopen("./logs/os.log", "a");
	fclose(templog);
	templog = fopen("./logs/cs_reg.log", "a");
	fclose(templog);
	templog = fopen("./logs/cs_id.log", "a");
	fclose(templog);
	templog = fopen("./logs/cs_own.log", "a");
	fclose(templog);
	templog = fopen("./logs/cs_misc.log", "a");
	fclose(templog);
	templog = fopen("./logs/cs_gpd.log", "a");
	fclose(templog);
	templog = fopen("./logs/cs_exp.log", "a");
	fclose(templog);
	templog = fopen("./logs/cs_flags.log", "a");
	fclose(templog);
}


/*********************************************************************************************/

int open_logs()
{
	create_dummy_logs();

	if (!logfile) {
		if ((logfile = fopen(log_name, "a")) == NULL) {
			fprintf(stderr, "Can't open logfile: %s (%d)\n", log_name, errno);
			return 0;
		} else if (logfile)
			setbuf(logfile, NULL);
	}



	return 1;
}

/*********************************************************************************************/

void close_logs()
{
	if (logfile) {
		fclose(logfile);
		logfile = NULL;
	}
}

/*********************************************************************************************/

void slog(int type, const char *fmt, va_list args)
{
	char buf[2048];
	FILE *logptr;

	logptr = logfile;

	vsnprintf(buf, sizeof(buf), fmt, args);

	if (logptr) {
		fputs(timebuf(0), logptr);
		fputs(buf, logptr);
		fputc('\n', logptr);
	}
	if (nofork) {
		fputs(timebuf(0), stderr);
		fputs(buf, stderr);
		fputc('\n', stderr);
	}

	if (sdebug)
		send_cmd(s_OperServ, "PRIVMSG %s :%s", SNOOPCHAN, buf);

}


/*********************************************************************************************/

void kill_logs(char *lastday)
{
	char fbuf[32], cyear[32], pbuf[2048];
	const char *mon = strtok(lastday, " "), *day = strtok(NULL, "");
	time_t t = time(NULL);
	struct tm tm = *localtime(&t);

	strftime(cyear, sizeof(cyear), "%Y", &tm);
	snprintf(fbuf, sizeof(fbuf), "%s_%s", mon, day);

	if (ORGANIZE) {
		snprintf(pbuf, sizeof(pbuf), "./logs/%s", cyear);
		if (chdir(pbuf) < 0) {
			snprintf(pbuf, sizeof(pbuf), "mkdir ./logs/%s", cyear);
			system(pbuf);
		} else
			chdir(DATDEST);
		sprintf(pbuf, "mv -f ./logs/temp.log ./logs/%s/%s.log", cyear, fbuf);
		system(pbuf);

		close_logs();
		sprintf(pbuf, "rm %s", log_name);
		system(pbuf);

		system("rm ./logs/ns_reg.log");
		system("rm ./logs/ns_id.log");
		system("rm ./logs/ns_own.log");
		system("rm ./logs/ns_gpd.log");
		system("rm ./logs/ns_flags.log");
		system("rm ./logs/ns_misc.log");
		system("rm ./logs/ns_exp.log");
		system("rm ./logs/os.log");
		system("rm ./logs/rs.log");
		system("rm ./logs/cs_reg.log");
		system("rm ./logs/cs_id.log");
		system("rm ./logs/cs_own.log");
		system("rm ./logs/cs_misc.log");
		system("rm ./logs/cs_gpd.log");
		system("rm ./logs/cs_exp.log");
		system("rm ./logs/cs_flags.log");

		open_logs();

	}

	system("rm ./logs/temp.log");

}


/*********************************************************************************************/

void check_logs(void)
{
	char buf[64], s_year[32], sent_time[64];
	char *lastday=0;
	struct tm tm;
	time_t t = time(NULL);
	FILE *templog, *sourcelog;
	int i,x,num_rows;

	if (!ORGANIZE)
		return;


	tm = *localtime(&t);
	strftime(buf, sizeof(buf), "%b %d", &tm);
	strftime(s_year, sizeof(s_year), "%Y", &tm);
	strftime(sent_time, sizeof(sent_time), "%H:%M:%S %Z", &tm);

	if (sql_select("log FROM sirv")) {
		row = fetch(res);
		if (row[0] != NULL)
			lastday = sstrdup(row[0]);
		else {            /* apparently a new database, set today as lastday */
			send_sql("UPDATE sirv SET log = '%s'", buf);
			return;
		}
	}

	if (lastday && sstrcmp(lastday, buf) != 0) {  /* time to do new day log routines */

		send_sql("UPDATE sirv SET log = '%s'", buf);

		templog = fopen("./logs/temp.log", "a");
		if (templog)
			setbuf(templog, NULL);
		else
			fatal_error("Error opening temporay log stream! - (%s)", strerror(errno));

		fprintf(templog, "* Services logs for %s %s ( Sorted at: %s )\n\n",
			lastday, s_year, sent_time);

		fprintf(templog, "* [NickServ Registry/Auth]:\n");
		if ((sourcelog = fopen("./logs/ns_reg.log", "r"))) {
			fseek(sourcelog, 0L, SEEK_END); i = ftell(sourcelog); rewind(sourcelog);
			for (x=0; x < i; x++)
				fputc(fgetc(sourcelog), templog);
			fclose(sourcelog);
			fputc('\n', templog); fputc('\n', templog);
		}

		fprintf(templog, "* [NickServ Identifies/Fails]:\n");
		if ((sourcelog = fopen("./logs/ns_id.log", "r"))) {
			fseek(sourcelog, 0L, SEEK_END); i = ftell(sourcelog); rewind(sourcelog);
			for (x=0; x < i; x++)
				fputc(fgetc(sourcelog), templog);
			fclose(sourcelog);
			fputc('\n', templog); fputc('\n', templog);
		}

		fprintf(templog, "* [NickServ Ownership Commands]:\n");
		if ((sourcelog = fopen("./logs/ns_own.log", "r"))) {
			fseek(sourcelog, 0L, SEEK_END); i = ftell(sourcelog); rewind(sourcelog);
			for (x=0; x < i; x++)
				fputc(fgetc(sourcelog), templog);
			fclose(sourcelog);
			fputc('\n', templog); fputc('\n', templog);
		}

		fprintf(templog, "* [NickServ Sendpass/Getpass]:\n");
		if ((sourcelog = fopen("./logs/ns_gpd.log", "r"))) {
			fseek(sourcelog, 0L, SEEK_END); i = ftell(sourcelog); rewind(sourcelog);
			for (x=0; x < i; x++)
				fputc(fgetc(sourcelog), templog);
			fclose(sourcelog);
			fputc('\n', templog); fputc('\n', templog);
		}

		fprintf(templog, "* [NickServ Flag Changes (Hold/Mark/Freeze/Forbid)]:\n");
		if ((sourcelog = fopen("./logs/ns_flags.log", "r"))) {
			fseek(sourcelog, 0L, SEEK_END); i = ftell(sourcelog); rewind(sourcelog);
			for (x=0; x < i; x++)
				fputc(fgetc(sourcelog), templog);
			fclose(sourcelog);
			fputc('\n', templog); fputc('\n', templog);
		}


		fprintf(templog, "* [NickServ Misc (Ghost/Recover/etc)]:\n");
		if ((sourcelog = fopen("./logs/ns_misc.log", "r"))) {
			fseek(sourcelog, 0L, SEEK_END); i = ftell(sourcelog); rewind(sourcelog);
			for (x=0; x < i; x++)
				fputc(fgetc(sourcelog), templog);
			fclose(sourcelog);
			fputc('\n', templog); fputc('\n', templog);
		}

		fprintf(templog, "* [NickServ Expiry]:\n");
		if ((sourcelog = fopen("./logs/ns_exp.log", "r"))) {
			fseek(sourcelog, 0L, SEEK_END); i = ftell(sourcelog); rewind(sourcelog);
			for (x=0; x < i; x++)
				fputc(fgetc(sourcelog), templog);
			fclose(sourcelog);
			fputc('\n', templog); fputc('\n', templog);
		}

		fprintf(templog, "* [OperServ Commands]:\n");
		if ((sourcelog = fopen("./logs/os.log", "r"))) {
			fseek(sourcelog, 0L, SEEK_END); i = ftell(sourcelog); rewind(sourcelog);
			for (x=0; x < i; x++)
				fputc(fgetc(sourcelog), templog);
			fclose(sourcelog);
			fputc('\n', templog); fputc('\n', templog);
		}

		fprintf(templog, "* [RootServ Commands]:\n");
		if ((sourcelog = fopen("./logs/rs.log", "r"))) {
			fseek(sourcelog, 0L, SEEK_END); i = ftell(sourcelog); rewind(sourcelog);
			for (x=0; x < i; x++)
				fputc(fgetc(sourcelog), templog);
			fclose(sourcelog);
			fputc('\n', templog); fputc('\n', templog);
		}

		fprintf(templog, "* [ChanServ Registry/Auth]:\n");
		if ((sourcelog = fopen("./logs/cs_reg.log", "r"))) {
			fseek(sourcelog, 0L, SEEK_END); i = ftell(sourcelog); rewind(sourcelog);
			for (x=0; x < i; x++)
				fputc(fgetc(sourcelog), templog);
			fclose(sourcelog);
			fputc('\n', templog); fputc('\n', templog);
		}

		fprintf(templog, "* [ChanServ Identifies/Fails]:\n");
		if ((sourcelog = fopen("./logs/cs_id.log", "r"))) {
			fseek(sourcelog, 0L, SEEK_END); i = ftell(sourcelog); rewind(sourcelog);
			for (x=0; x < i; x++)
				fputc(fgetc(sourcelog), templog);
			fclose(sourcelog);
			fputc('\n', templog); fputc('\n', templog);
		}

		fprintf(templog, "* [ChanServ Ownership Commands]:\n");
		if ((sourcelog = fopen("./logs/cs_own.log", "r"))) {
			fseek(sourcelog, 0L, SEEK_END); i = ftell(sourcelog); rewind(sourcelog);
			for (x=0; x < i; x++)
				fputc(fgetc(sourcelog), templog);
			fclose(sourcelog);
			fputc('\n', templog); fputc('\n', templog);
		}

		fprintf(templog, "* [ChanServ Misc Commands]:\n");
		if ((sourcelog = fopen("./logs/cs_misc.log", "r"))) {
			fseek(sourcelog, 0L, SEEK_END); i = ftell(sourcelog); rewind(sourcelog);
			for (x=0; x < i; x++)
				fputc(fgetc(sourcelog), templog);
			fclose(sourcelog);
			fputc('\n', templog); fputc('\n', templog);
		}

		fprintf(templog, "* [ChanServ Sendpass/Getpass Commands]:\n");
		if ((sourcelog = fopen("./logs/cs_gpd.log", "r"))) {
			fseek(sourcelog, 0L, SEEK_END); i = ftell(sourcelog); rewind(sourcelog);
			for (x=0; x < i; x++)
				fputc(fgetc(sourcelog), templog);
			fclose(sourcelog);
			fputc('\n', templog); fputc('\n', templog);
		}

		fprintf(templog, "* [ChanServ Expiry]:\n");
		if ((sourcelog = fopen("./logs/cs_exp.log", "r"))) {
			fseek(sourcelog, 0L, SEEK_END); i = ftell(sourcelog); rewind(sourcelog);
			for (x=0; x < i; x++)
				fputc(fgetc(sourcelog), templog);
			fclose(sourcelog);
			fputc('\n', templog); fputc('\n', templog);
		}

		fprintf(templog, "* [ChanServ Flag Changes (Hold/Mark/Freeze/Forbid)]:\n");
		if ((sourcelog = fopen("./logs/cs_flags.log", "r"))) {
			fseek(sourcelog, 0L, SEEK_END); i = ftell(sourcelog); rewind(sourcelog);
			for (x=0; x < i; x++)
				fputc(fgetc(sourcelog), templog);
			fclose(sourcelog);
			fputc('\n', templog); fputc('\n', templog);
		}

		fclose(templog);

		if (SEND_LOGS) {
			num_rows=sql_select("nick.email,nick.name FROM nick,oper WHERE oper.sendlog = 1 AND "
				"oper.name=nick.name");

			for (i=0; i < num_rows; i++) {
				char buffer[1024];
				FILE *mailpipe = popen(SENDMAIL_PATH, "w");
				FILE *elog = fopen("./logs/temp.log", "r");

				char time_buf[64];
				row = fetch(res);


				strftime(time_buf, sizeof(time_buf), "%a %b %d %H:%M:%S %Y %Z", &tm);
				time_buf[sizeof(time_buf)-1] = 0;

				fprintf(mailpipe, "Date: %s\n", time_buf);
				fprintf(mailpipe, "From: %s <%s>\n", NETWORK_NAME, RETURN_EMAIL);
				fprintf(mailpipe, "To: %s <%s>\n", row[1], row[0]);
				fprintf(mailpipe, "Subject: Services Logs\n\n");
				
				if (elog) {
					while (!feof(elog)) {
						fgets(buffer, 1024, elog);
						fprintf(mailpipe, buffer);

					}
					fclose(elog);
				}

				pclose(mailpipe);
			}
			globops(NULL, "Sorted and e-mailed services logs. (%d e-mail%s.)", 
				num_rows, num_rows==1 ? "" : "s");
		}

		kill_logs(lastday);

	}
	free(lastday);
}


/*********************************************************************************************/

/* Break log routine - organize service commands into separate logs */


void blog(const char *service, const char *fmt,...)
{
	va_list args, cpargs;
	time_t t;
	struct tm tm;
	char buf[1024];

	va_start(args, fmt);
	time(&t);
	tm = *localtime(&t);
	strftime(buf, sizeof(buf)-1, "[%b %d %H:%M:%S %Y] ", &tm);

	va_copy(cpargs, args);
	slog(1, fmt, cpargs);
	va_end(cpargs);


	if (SNOOP && uburst) {
		char snooplog[512];
		va_copy(cpargs, args);
		vsnprintf(snooplog, sizeof(snooplog), fmt, args);
		send_cmd(s_OperServ, "PRIVMSG %s :%s", SNOOPCHAN, snooplog);
		va_end(cpargs);
	}



	if (ORGANIZE) {
		FILE *templog=0;

		if (strstr(service, "NS_R"))        /* nickserv register */
			templog = fopen("./logs/ns_reg.log", "a");
		else if (strstr(service, "NS_I"))   /* nickserv identify */
			templog = fopen("./logs/ns_id.log", "a");
		else if (strstr(service, "NS_O"))   /* nickserv ownership */
			templog = fopen("./logs/ns_own.log", "a");
		else if (strstr(service, "NS_S"))   /* nickserv getpass/sendpass */
			templog = fopen("./logs/ns_gpd.log", "a");
		else if (strstr(service, "NS_F"))   /* nickserv flags */
			templog = fopen("./logs/ns_flags.log", "a");
		else if (strstr(service, "NS_M"))   /* nickserv misc */
			templog = fopen("./logs/ns_misc.log", "a");
		else if (strstr(service, "NS_X"))   /* nickserv expiry */
			templog = fopen("./logs/ns_exp.log", "a");
		else if (strstr(service, "OS"))     /* OperServ */
			templog = fopen("./logs/os.log", "a");
		else if (strstr(service, "RS"))    /* RootServ */
			templog = fopen("./logs/rs.log", "a");
		else if (strstr(service, "LSEARCH"))   /* Log Search */
			templog = fopen("./logs/lsearch.log", "a");
		else if (strstr(service, "CS_R"))  /* chanserv register */
			templog = fopen("./logs/cs_reg.log", "a");
		else if (strstr(service, "CS_I"))  /* chanserv identifies */
			templog = fopen("./logs/cs_id.log", "a");
		else if (strstr(service, "CS_O"))  /* chanserv ownership */
			templog = fopen("./logs/cs_own.log", "a");
		else if (strstr(service, "CS_M"))  /* chanserv misc */
			templog = fopen("./logs/cs_misc.log", "a");
		else if (strstr(service, "CS_F"))   /* chanserv flags */
			templog = fopen("./logs/cs_flags.log", "a");
		else if (strstr(service, "CS_S"))  /* chanserv getpass/sendpass */
			templog = fopen("./logs/cs_gpd.log", "a");
		else if (strstr(service, "CS_X"))  /* chanserv expiry */
			templog = fopen("./logs/cs_exp.log", "a");


		if (templog) {
			va_copy(cpargs, args);
			fputs(buf, templog);
			vfprintf(templog, fmt, cpargs);
			fputc('\n', templog);
			fclose(templog);
			va_end(cpargs);
		}
	}
	va_end(args);
}


/*********************************************************************************************/
/*********************************************************************************************/

