/*
 * SirvNET Services are copyright (c) 1998-2006 Trevor Klingbeil.
 *    http://www.sirv.net  ::  ftp.sirv.net
 * This program is copyrighted software; see the file COPYING for details.
 * Parts of this file are originally based on EsperNet Services(c) by Andy Church.
 */


#include "services.h"
#include "log.h"


/*******************************************************************/
/*******************************************************************/
inline long getrandom(int min, int max)
{
	srand((unsigned)time(NULL));
	return get_random(min, max);
}


/*******************************************************************/

char *create_ticket() {
	int tlength = get_random(15,20);
	int i,z,unique=0;
	char ticket[24], chr[2], *p;


	while (!unique) {
		srand((unsigned)time(NULL));
		*ticket=0;

		for (i=0; i < tlength; i++) {
			z = get_random(1,3);
			switch(z) {
				case 1:
					snprintf(chr, 2, "%d", (int)get_random(1,9));
					strcat(ticket, chr);
					break;
				case 2:
					snprintf(chr, 2, "%c", (char)get_random(65,90));
					strcat(ticket, chr);
					break;
				case 3:
					snprintf(chr, 2, "%c", (char)get_random(97,122));
					strcat(ticket, chr);
					break;
			}
		}
		if (!(sql_select("ticket FROM akill WHERE ticket = '%s'", ticket)))
			unique=1;
	}

	return p=sstrdup(ticket);
}


/*******************************************************************/

char *calcltime(time_t t)
{
	char buf[256], *p;

	if (t < 60) {
		sprintf(buf, "In under a minute.");

	} else if (t < 3600) {
		sprintf(buf, "%ld minute%s.",
			t/60, t<120 ? "" : "s");

	} else if (t < 86400) {
		t /= 60;
		sprintf(buf, "%ld hour%s %ld minute%s.",
			t/60, t<120 ? "" : "s", t%60, t%60==1 ? "" : "s");

	} else {
		sprintf(buf, "%ld day%s, %ld hour%s.", 
			t/86400, t/86400==1 ? "" : "s",
			(t/3600)%24, (t/3600)%24==1 ? "" : "s");
	}
	return p=buf;
}


char *timebuf(time_t tnum)
{
	time_t t = tnum;
	struct tm tm;
	static char buf[256];
	char *result;


	if (!t)
		time(&t);


	tm = *localtime(&t);
	strftime(buf, sizeof(buf)-1, "[%b %d %H:%M:%S %Y] ", &tm);


	result = buf;
	return result;
}




/*******************************************************************/

char *merge_args(int argc, char **argv)
{
    int i;
    static char s[4096];
    char *t;

    t = s;
    for (i = 0; i < argc; ++i)
        t += snprintf(t, sizeof(s)-(t-s), "%s%s", *argv++, (i<argc-1) ? " " : "");
    return s;
}

/*******************************************************************/

#define NICK(server,nick,name,sock) do { send_cmd(NULL, "NICK %s 1 %lu %s %s %s %s 0 0 :%s", (nick), time(NULL), "+", services_user, services_host, server, (name)); } while (0)


void load_pseudo_clients(const char *user)
{
#ifndef SKELETON
	if (!user || sstrcmp(user, "Guest") == 0)
		NICK(servername, "Guest", "Guest redirection", servfd);
	if (!user || sstrcmp(user, s_NickServ) == 0)
		NICK(servername, s_NickServ, "Nickname Services", servfd);
	if (!user || sstrcmp(user, s_ChanServ) == 0)
		NICK(servername, s_ChanServ, "Channel Services", servfd);
	if (!user || sstrcmp(user, s_MemoServ) == 0)
		NICK(servername, s_MemoServ, "Memo Services", servfd);
	if (!user || sstrcmp(user, s_HelpServ) == 0)
		NICK(servername, s_HelpServ, "Help Services", servfd);
	if (!user || sstrcmp(user, s_StatServ) == 0)
		NICK(statsname, s_StatServ, "Statistical Database", statfd);
#endif

	if (!user || sstrcmp(user, s_Global) == 0)
		NICK(servername, s_Global, "Network Global Noticer", servfd);
	if (!user || sstrcmp(user, s_OperServ) == 0)
		NICK(statsname, s_OperServ, "Operator Services", servfd);
	if (!user || sstrcmp(user, s_RootServ) == 0)
		NICK(servername, s_RootServ, "Services Root Access", servfd);

}

/*******************************************************************/

void cripple_pseudo()
{

	globops(NULL, "Lost connection to SQL Database!");
	globops(NULL, "Limiting services functions until database "
		"connection is restored.");
}

/*******************************************************************/

void notice(const char *source, const char *dest, const char *fmt,...)
{
	va_list args;
	char buf[1024];

	va_start(args, fmt);
	vsnprintf(buf, sizeof(buf), fmt, args);

	send_cmd(source, "NOTICE %s :%s", dest, buf);


}

/*******************************************************************/

static int to_upper(char c)
{
	if (islower(c))
		return (unsigned char)c - ('a'-'A');
	else
		return (unsigned char)c;
}

static int to_lower(char c)
{
	if (isupper(c))
		return (unsigned char)c + ('a'-'A');
	else
		return (unsigned char)c;
}


/*******************************************************************/

char *strupper(char *s)
{
	char *t = s;
	while (*t) {
		*t = to_upper(*t);
		*t++;
	}
	return s;
}

char *strlower(char *s)
{
	char *t = s;
	while (*t) {
		*t = to_lower(*t);
		*t++;
	}
	return s;
}


/*******************************************************************/

/* match_wild:  Attempt to match a string to a pattern which might contain
 *              '*' or '?' wildcards.  Return 1 if the string matches the
 *              pattern, 0 if not.
 */

static int do_match_wild(const char *pattern, const char *str, int docase)
{
	char c;
	const char *s;

	/* This WILL eventually terminate: either by *pattern == 0, or by a
	* trailing '*'. */

	for (;;) {
		switch (c = *pattern++) {
		case 0:
			if (!*str)
				return 1;
			return 0;
		case '?':
			if (!*str)
				return 0;
			++str;
			break;
		case '*':
			if (!*pattern)
				return 1;       /* trailing '*' matches everything else */
			s = str;
			while (*s) {
				if ((docase ? (*s==*pattern) : (to_lower(*s)==to_lower(*pattern)))
					&& do_match_wild(pattern, s, docase))
					return 1;
			++s;
			}
		break;
		default:
			if (docase ? (*str++ != c) : (to_lower(*str++) != to_lower(c)))
				return 0;
			break;
		} /* switch */
	}
}

int match_wild(const char *pattern, const char *str)
{
    return do_match_wild(pattern, str, 1);
}

int match_wild_nocase(const char *pattern, const char *str)
{
	return do_match_wild(pattern, str, 0);
}


/*******************************************************************/


void globops(const char *source, const char *fmt,...)
{
	va_list args;
	char buf[1024];

	va_start(args, fmt);
	vsnprintf(buf, sizeof(buf), fmt, args);
	send_cmd(source, "GLOBOPS :%s", buf);
	va_end(args);



}

/*******************************************************************/

void bad_password(User *u, const char *target)
{

	if (BAD_PW_LIMIT == 0)
		return;


	if (BAD_PW_TIMEOUT) {
		if ((u->invalid_time > 0) && (u->invalid_time < time(NULL)-BAD_PW_TIMEOUT))
			u->invalid_nicks = 0;
			u->invalid_chans = 0;
	}

	u->invalid_time = time(NULL);

	if (*target == '#') {
		u->invalid_chans++;
		if (u->invalid_chans >= BAD_PW_LIMIT) {
			blog("CS_I", "CS *I %s (%s!%s@%s) [Abusive - Killed]",
				target, u->nick, u->username, u->host);
			kill_user(s_NickServ, u->nick, "Too many invalid passwords.");
		}
	} else {
		u->invalid_nicks++;
		if (u->invalid_nicks >= BAD_PW_LIMIT) {
			blog("NS_I", "NS *I %s (%s!%s@%s) [Abusive - Killed]",
				target, u->nick, u->username, u->host);
			kill_user(s_NickServ, u->nick, "Too many invalid passwords.");
		}
	}
}


/*******************************************************************/

void kill_user(const char *source, const char *target, const char *reason)
{
	User *user = finduser(target);

	char *av[2];
	if (!user || !source || !target)
		return;

	if (!reason)
		reason = "";

	av[0] = sstrdup(user->nick);
	av[1] = smalloc(strlen(source)+strlen(reason)+4);
	sprintf(av[1], "%s (%s)", source, reason);
#ifndef BAHAMUT
	send_cmd(source, "SVSKILL %s :%s", user->nick, reason);
#else
	send_cmd(source, "SVSKILL %s %ld :%s", user->nick, user->signon, reason);
#endif
	do_kill((char *)source, 2, av);
	free(av[0]); free(av[1]);
}


/*******************************************************************/


int check_servii_kill(const char *source, int ac, char **av)
{
	User *u;
	int server=0;

	u = finduser(source);
	if (!u)
		server=1;

	if (!sstrcmp(av[0],s_ChanServ) || !sstrcmp(av[0],s_NickServ)
	|| !sstrcmp(av[0],s_OperServ) || !sstrcmp(av[0],s_MemoServ)
	|| !sstrcmp(av[0],s_Global) || !sstrcmp(av[0],s_HelpServ)
	|| !sstrcmp(av[0], s_RootServ) || !sstrcmp(av[0], "Guest")) {


		if (!sstrcmp(av[0],s_StatServ)) {
			load_pseudo_clients(s_StatServ);
			globops(NULL, "%s revived after being killed", s_StatServ);
		} else {
			load_pseudo_clients(av[0]);
			globops(NULL, "%s revived after being killed", av[0]);
		}

		if (!server) {
			notice(s_Global, source, "Do \2NOT\2 kill services!");
			if (!sstrcmp(av[0], s_StatServ)) {
				globops(NULL, "%s tried to kill %s!",
					source, s_StatServ);
				send_cmd(NULL, "SVSMODE %s -o %ld", source, time(NULL));
			} else {
				globops(NULL, "%s tried to kill a services client!",
					source);
				send_cmd(NULL, "SVSMODE %s -o %ld", source, time(NULL));

			}
		}
		return 1;
	}


	return 0;
}

/*******************************************************************/

/* Return current nick or oper's nick of authority. If db is true, place nick of authority in parenthesis */

char *opertrace(User *u, int db)
{
	char buf[NICKMAX*2 +3], *p;

	if (!u->os_nick)
		return u->nick;

	if (sstrcmp(u->nick, u->os_nick) == 0)
		return u->nick;

	if (db)
		return u->os_nick;

	sprintf(buf, "%s (%s)", u->nick, u->os_nick);

	return p=buf;
}

/*******************************************************************/

void check_jupe(const char *server)
{
	if (sql_select("reason,instater FROM jupiter WHERE name = '%s'", server)) {
		row = fetch(res);
		send_cmd(NULL, "SQUIT %s :Jupitered server [%s]", server, row[0]);
		send_cmd(NULL, "SERVER %s 2 :Jupitered server (Request of: %s) [%s]",
			server, row[1], row[0]);
	}
}

/*******************************************************************/

int check_valid_url(const char *source, const char *url)
{
        char copy[60];
        char *s, *header;
        unsigned int mailto=0, point=0;

        if (strncmp(url, "ftp://", 6) && strncmp(url, "http://", 7)
                && strncmp(url, "mailto:", 7)) {
                        notice(s_NickServ, source,
                                "URL must be in the form of "
                                "http://host, ftp://host or mailto:email@address.com");
                return 0;

       } else if (strlen(url) > 60 || strlen(url) < 10) {
                        notice(s_NickServ, source,
                                "Invalid URL: Minimum or Maximum length exceeded.");
                        return 0;

        }

        strcpy(copy, url);
        header = strtok(copy, ":");  /* pointer to URL type and separates the host for error checking */
        s = strtok(NULL, "");

        if (!strchr(s, '/'))
                mailto=1;
        else { *s++;s++; }


        if (mailto) {
                if (!check_valid_email(s)) {
                        notice(s_NickServ, source, INVALID_EMAIL);
                        return 0;
                }
                return 1;
  /* ftp:// or http://  */

        } else {
                if ((strspn(s, "1234567890abcdefghijklmnopqrstuvwxyz"
                                "ABCDEFGHIJKLMNOPQRSTUVWXYZ_/.-") != strlen(s))) {
                        notice(s_NickServ, source,
                                "URL ERROR: Invalid characters in %s address.", header);
                        return 0;

                }
        }
        while (*url) {
                if (*url == '.') {
                        if (!point)
                                point=1;
                        else {
                                notice(s_NickServ, source,
                                        "ERROR: Invalid %s address", header);
                                return 0;
                        }
                } else
                        point=0;
                *url++;
	}
	return 1;
}

/*******************************************************************/

int check_valid_mask(const char *mask)
{

	char *ptr = strchr(mask, '@');
	int point=0;

	if (!ptr)
		return 0;


	if (strchr(mask, '!'))
		return 0;

	if ((strspn(++ptr, "1234567890"
		"abcdefghijklmnopqrstuvwxyz"
		"ABCDEFGHIJKLMNOPQRSTUVWXYZ-*.") != strlen(ptr)))
		return 0;

	if (*ptr == 0)  /* no characters after @ given */
		return 0;

	if (*ptr == '-')
		return 0;

	while (*ptr) {
		if (*ptr == '.') {
			if (!point)
				point=1;
			else
				return 0;
		} else
			point=0;
		*ptr++;
	}

	return 1;
}

/*******************************************************************/

int check_valid_host(const char *host)
{
	int point=0;

	if ((strspn(host, "1234567890"
		"abcdefghijklmnopqrstuvwxyz"
		"ABCDEFGHIJKLMNOPQRSTUVWXYZ-*.") != strlen(host)))
		return 0;

	while (*host) {
		if (*host == '.') {
			if (!point)
				point=1;
			else
				return 0;
		} else
			point=0;
		*host++;
	}

	return 1;
}

/*******************************************************************/

int check_valid_ip(const char *ip)
{
	char *brkp = sstrdup(ip);
	char *a1 = strtok(brkp, "."), *a2 = strtok(NULL, ".");
	char *a3 = strtok(NULL, "."), *a4 = strtok(NULL, ".");
	char *a5 = strtok(NULL, "");
	int i=1;

	if (a5)
		i=0;

	if (strspn(ip, "1234567890.*") != strlen(ip))
		i=0;

	else if (!a1 || !a2 || !a3 || !a4)
		i=0;
		
	else if (((atoi(a1) < 1) || (atoi(a1) > 255)) ||
		(atoi(a2) < 0) || (atoi(a2) > 255) ||
		(atoi(a3) < 0) || (atoi(a3) > 255) ||
		(atoi(a4) < 0) || (atoi(a4) > 255))
		i=0;
		
	free(brkp);
	return i;
}

/*******************************************************************/

void expire_akills()
{
	AKill *akill;
	int num_rows, i;

	if (!(num_rows = sql_select("mask FROM akill WHERE expire <= %d AND expire <> 0", time(NULL))))
		return;

	for (i=0; i < num_rows; i++) {
		row = fetch(res);
		for (akill = akill_list; akill; akill = akill->next) {
			if (sstrcmp(akill->mask, row[0]) == 0) {
#ifndef BAHAMUT  /* Bahamut will control it's own timed akills */
				char *s = sstrdup(akill->mask);
				char *host = strchr(s, '@');
				*host++ = 0;
				send_cmd(servername, "RAKILL %s %s", host, s);
				free(s);
#endif
				globops(NULL, OS_RAKILL, akill->mask);
				akills(akill->mask, 0, 0);
				break;
			}
		}
	}
	send_sql("DELETE FROM akill WHERE expire <= %d AND expire <> 0", time(NULL));

}

/*******************************************************************/

void expire_ignores()
{
	Ignore *ignore;
	int num_rows, i;


	if (!(num_rows = sql_select("mask FROM silence WHERE expire <= %d AND expire <> 0", time(NULL))))
		return;

	for (i=0; i < num_rows; i++) {
		row = fetch(res);
		for (ignore = ignore_list; ignore; ignore = ignore->next) {
			if (sstrcmp(ignore->mask, row[0]) == 0) {
				globops(NULL, OS_RIGNORE, ignore->mask);
				ignores(ignore->mask, 0);
				break;
			}
		}
	}
	send_sql("DELETE FROM silence WHERE expire <= %d", time(NULL));
}


/*******************************************************************/

void expire_closures()
{
	CloseChans *cc=closelist, *cc2;

	while (cc) {
		cc2 = cc->next;
		if (cc->expiry && cc->expiry <= time(NULL)) {
			send_sql("UPDATE cflags SET closed=0 WHERE name='%s'", cc->chan);
			send_sql("DELETE FROM reason WHERE name='%s' AND type='CLOSED'", cc->chan);
			if (cc->prev)
				cc->prev->next = cc->next;
			else
				closelist = cc->next;
			if (cc->next)
				cc->next->prev = cc->prev;
			free(cc->chan); free(cc);
		}
		cc = cc2;
	}


}


/*******************************************************************/

int check_ignore(const char *username, const char *host)
{
	Ignore *ignore;
	char buf[512];
	int i;

	strncpy(buf, username, sizeof(buf)-2);
	i = strlen(buf);
	buf[i++] = '@';
	strncpy(buf+i, host, sizeof(buf)-i);


	for (ignore = ignore_list; ignore; ignore = ignore->next) {
		if (match_wild_nocase(ignore->mask, buf))
			return 1;
	}
	return 0;
}


/*******************************************************************/

int akill_key(const char *mask)
{

	AKill *akill;

	for (akill = akill_list; akill; akill = akill->next) {
		if (sstrcmp(akill->mask, mask) == 0)
			return akill->id;
	}
	return 0;
}

/*******************************************************************/

static void set_akill(AKill *a)
{
	char reason[1024], *tmask, *s;

	if (!(sql_select("ticket,instater,expire,reason FROM akill WHERE id = %d", a->id))) {
		if (debug)
			log("Internal AKILL found that is not in database: %s", a->mask);
		akills(a->mask,0,0);
		return;
	}
	row = fetch(res);

	tmask = sstrdup(a->mask);

	s = strchr(tmask, '@');
	if (s)
		*s++ = 0;
		
	snprintf(reason, sizeof(reason), "%s (Ticket ID: %s)", 
		AKILL_REASONS ? row[3] : "You have been Auto-Killed.", row[0]);
	send_cmd(NULL, "AKILL %s %s %ld %s %ld :%s",
		s, tmask, atol(row[2])-time(NULL), row[1], time(NULL),reason);

	free(tmask);
}

int check_akill(const char *nick, const char *username, const char *host)
{
	AKill *akill;
	char buf[1024];
	int i;

	strncpy(buf, username, sizeof(buf)-2);
	i = strlen(buf);
	buf[i++] = '@';
	strncpy(buf+i, host, sizeof(buf)-i);
	for (akill = akill_list; akill; akill = akill->next) {
		if (!(akill->flag & AK_WILD_IDENT) && !(akill->flag & AK_WILD_HOST)) {
			if (sstrcmp(akill->mask, buf) == 0) {
				set_akill(akill);
			}

		} else if (!(akill->flag & AK_WILD_IDENT)) {
			char *s = sstrdup(akill->mask);
			char *p = strtok(s, "@");
			if (!p || sstrcmp(p, username)) {
				free(s);
				continue;
			} else {
				p = strtok(NULL, "");
				if (p && match_wild_nocase(p, host))
					set_akill(akill);
			}
			free (s);
		} else if (!(akill->flag & AK_WILD_HOST)) {
			char *p, *s = strchr(akill->mask, '@');
			if (!s || sstrcmp(s, akill->mask))
				continue;
			else {
				s = sstrdup(akill->mask);
				p = strtok(s, "@");
				if (match_wild_nocase(p, username))
					set_akill(akill);
				free(s);
			}

		} else if (match_wild_nocase(akill->mask, buf)) {
			set_akill(akill);
		}
	}
	return 0;
}

void mass_check_akill()
{
	User *user;
	int ulist=0;
	for (ulist=0; ulist < 256; ulist++) {
		for (user = userlist[ulist]; user; user = user->next) {
			check_akill(user->nick, user->username, user->host);
		}
	}
}

/*******************************************************************/

/*
 * After connection success to services HUB - send database akills.
 * Bahamut will take care of all timed akills so we won't have to do anything more.
 * This function also gets called once a week to make sure our permanent akills don't expire.
 * Bahamut only holds "permanent" akills for 1 week by default.
 * We RAKILL the enteries to also make sure they last a week. Bahamut will ignore any AKILL
 * message it gets for an already existing entry.
 */

#ifdef BAHAMUT

void send_akills()
{
	char *s, reason[256], *mask;
	int i, timed=0, num_rows = sql_select("* FROM akill");


	for (i=0; i < num_rows; i++) {
		row = fetch(res);
		mask = sstrdup(row[1]);
		s = strchr(mask, '@');
		if (s)
			*s++ = 0;

		snprintf(reason, sizeof(reason), "%s (Ticket ID: %s)", 
			AKILL_REASONS ? row[4] : "You have been Auto-Killed.", row[6]);

		if (atoi(row[3]) == 0) /* permanent */
			timed=0;
		else if ((timed=(atoi(row[3]) - time(NULL))) < 1) { /* expired */
			free(mask);
			continue;
		}
		send_cmd(NULL, "RAKILL %s %s", s, mask);

		send_cmd(NULL, "AKILL %s %s %d %s %d :%s",
			s, mask, timed, row[5], time(NULL), reason);
		free(mask);

	}

}
#endif

/*******************************************************************/

void send_sqlines()
{
	int i, num_rows = sql_select("name,reason FROM sqline");

	for (i=0; i < num_rows; i++) {
		row = fetch(res);
		send_cmd(NULL, "SQLINE %s :%s", row[0], row[1]);
	}
}

/*******************************************************************/

void send_sglines()
{
	int i, num_rows = sql_select("name,reason FROM sgline");

	for (i=0; i < num_rows; i++) {
		row = fetch(res);
		send_cmd(NULL, "SGLINE %d :%s:%s", strlen(row[0]), row[0], row[1]);
	}
}



/*******************************************************************/

int is_frozen(const char *f)
{
	nfreezes *nf;

	for (nf = freezelist; nf; nf = nf->next) {
		if (sstrcmp(nf->ent, f) == 0)
			return 1;
	}

	return 0;
}



/*******************************************************************/

/* Insures the token doesn't exceed LENMAX. This prevents possible notice replies from exceeding
   the IRC message buffer. */

char *gettok(char *buf, const char *delim, int LENMAX)
{
        char *tok = strtok(buf, delim);
        char *ptr = tok;

        if (!tok)
                return 0;

        if (strlen(tok) <= (size_t)LENMAX)
                return tok;

        ptr += LENMAX; *ptr = 0;

        return tok;
}


/*******************************************************************/

int check_escape_codes(const char *s)
{
	while (*s) {
		if ((unsigned char)*s < (unsigned char)' ')
			return 1;
		*s++;
	}
	return 0;
}

/*******************************************************************/

long generate_primary_id(const char *table)
{
        int dupl=0;
        unsigned long id=1;

	if (sstrcmp(table, "akill") == 0) {
		AKill *akill = akill_list;
		while (akill) {
			if (akill->id == id) { id++; akill = akill_list; }
			else
				akill = akill->next;
		}
		return id;
	}

        while (dupl != -1) {
                id = getrandom(1,2000000000);
                if (!sql_select("id FROM %s WHERE id = %d", table, id))
                        dupl = -1;
        }
        return id;
}

/*******************************************************************/

char *mask_host(const char *usermask)
{
	char *username, *copy, *ptr, *ptr2, *host, *mask;

	if (!usermask)
		return NULL;

	copy = sstrdup(usermask);

	if (!(username = strchr(copy, '@')))
		return copy;


	*username++ = 0;

	if ((ptr = strchr(username, '.'))) {
		*ptr++ = 0;
		if ((ptr2 = strchr(ptr, '.'))) {
			*ptr2++ = 0;
			host = ptr2;
		} else
			host = ptr;
	} else { free(copy); return NULL; }

	mask = smalloc(strlen(copy) + strlen(host) + 6);

	sprintf(mask, "%s@***.%s", copy, host);

	free(copy);
	return mask;

}

/*******************************************************************/
/*******************************************************************/


